#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 84 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
unsigned char CRam1[80];
char TEXTE[128];
char *txt;
#line 96 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
const char Colors[][6]={"Rouge","Vert ","Bleu ","..?.."};
volatile unsigned int Flag_Timer0;
volatile unsigned int Cpt0;
volatile unsigned int Flag_Timer1;
volatile unsigned int Cpt1;

unsigned int i,j,k,l;
unsigned int M;
unsigned int EA0,EA1,EA2 ;
unsigned int Table_EA[8];
unsigned int Nbval;
int Flag_First_Run=0;


unsigned long Freq;
float f1;

unsigned char Cde,Pos,Etat_PORTB;
unsigned char LedNum;


unsigned char c,cc,cx;
static unsigned char RGB_Led[8][3];
unsigned char Cde_RGB_Leds[8]={0xFE,0xFD, 0xFB,0xF7,0xEF, 0xDF, 0xBF,0x7F};
unsigned char Cde_RGB_Colors[3]={6,5,3};
volatile char RGB_Led_Now;
volatile char Cpt_RGB_Leds;
volatile char Cpt_Color, SetColor;
unsigned int ValColor;
unsigned char ColorR,ColorV,ColorB;




unsigned char buffer1[ 128 ];
unsigned int Index1=0;
unsigned int i1=0;
unsigned int UART1_DataReady=0;
unsigned char c1=0;
unsigned char *p1;


void strConstRamCpy(char *dest, const char *source);
void Init_Timer4(void);
void Init_Timer1(void);
void Init_Timer2(unsigned char x);
void UART1_Write_CText(const char *txt1);
void CRLF1(void);
void RAZ_UART1(void);
void Init_Hardware(void);
void Liste_Table(void);
void LOAD_Table_RGB(void);


void Interrupts() iv 0x0008 ics ICS_AUTO
{


 if((RC1IF_bit==1) && (RC1IE_bit==1))
 {
 c1 = RCREG1;

 if(OERR1_bit)
 {
 CREN1_bit = 0;
 CREN1_bit = 1;
 }
 if(FERR1_bit)
 {
 c1 = RCREG1;

 }

 if (c1==13)
 {
 UART1_DataReady=1;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 if (i1 >= 128 )
 {
 UART1_DataReady=2;
 RC1IE_bit=0 ;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 }




 if((TMR2IE_bit==1) && (TMR2IF_bit==1))
 {

 LATD=0xFF;
 TMR2ON_bit=0;
 TMR2IF_bit=0;
 }

 if((TMR4IE_bit==1) && (TMR4IF_bit==1))
 {
 RGB_Led_Now =(1<< Cpt_RGB_Leds);

 LATD = Cde_RGB_Leds[Cpt_RGB_Leds];
 cx= PORTC & 0xF8 ;
 SetColor=Cde_RGB_Colors[Cpt_Color];
 LATC= cx + SetColor;
 cc= RGB_Led[Cpt_RGB_Leds][Cpt_Color];
 Init_Timer2(cc);
 Cpt_Color++;
 if (Cpt_Color >2)
 {
 Cpt_Color=0 ;
 Cpt_RGB_Leds++;
 if (Cpt_RGB_Leds>7) Cpt_RGB_Leds=0;
 }

 TMR4IF_bit=0;
 }
#line 275 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
}

void Init_Timer2(unsigned char x)
 {
 T2CON=0;

 T2CKPS1_bit=0;
 T2CKPS0_bit=1;
#line 294 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
 T2OUTPS1_bit=1;
 T2OUTPS0_bit=1;



 T2OUTPS3_bit=1;
 T2OUTPS1_bit=0;

 TMR2=0;
 PR2= x ;
 TMR2IF_bit=0;
 TMR2IE_bit=1;
 TMR2ON_bit=1;
}

void Init_Timer4()
 {
 T4CON=0;
#line 323 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
 T4OUTPS3_bit=0;
 T4OUTPS2_bit=0;
 T4OUTPS1_bit=1;
 T4OUTPS0_bit=1;




 T4CKPS1_bit=0;
 T4CKPS0_bit=1;
 TMR4=0;
 PR4= 254 ;
 TMR4IF_bit=0;
 TMR4IE_bit=1;
 TMR4ON_bit=1;

}

void Init_Timer1(void)
{


 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 T1OSCEN_bit=0;
 T1CON.SYNC=0;
 T1CON.TMR1CS1=0;
 T1CON.TMR1CS0=0;
 T1CON.TMR1ON=0;







 TMR1H= 0xA2;
 TMR1L =0x3F ;

 IPR1.TMR1IP=1;
 RCON.IPEN = 1;
 TMR1IF_bit=0;
 INTCON.PEIE = 0;
 T1CON.TMR1ON=0;
 PIE1.TMR1IE=0;
 GIE_bit = 0;
}



void strConstRamCpy(char *dest, const char *source)
{
 while(*source) *(dest++) = *(source++) ;
 *dest = 0 ;
}


void UART1_Write_CText(const char *txt1)
{
 while (*txt1)
 UART1_Write(*(txt1++));
}

void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

 void RAZ_UART1()
{
 RC1IE_bit=0 ;
 for (i1=0;i1< 128 ;i1++) buffer1[i1]=0;
 i1=0;
 Index1=0;
 c1=RCREG1;
 c1=0;
 UART1_DataReady=0;
 RC1IE_bit=1 ;
}


void Init_Hardware()
{
 PMD0=0;
 C1ON_bit = 0;
 C2ON_bit = 0;
 PORTB = 0;
 TRISB=0x00;
 ANSELB=0;
 LATB=0;

 PORTA = 0xFF;
 TRISA=0b11100111 ;
 ANSELA=0x01;

 ANSELC=0;
 PORTC = 0xFF;
 TRISC=0b10111000 ;

 ANSELE=0;
 TRISE=0;
 PORTE=0xFF;

 PORTD = 0;
 TRISD=0;
 LATD=0xFF;
 ANSELD = 0;
 HLVDCON.HLVDEN=0;
 }
#line 439 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
 void Liste_Table()
 { int i;
 for (i=0;i<8;i++)
 {
 UART1_Write_CText("Lednum=");UART1_Write(i+48);
 UART1_Write_CText(" Rouge=");ByteToStr(RGB_Led[i][0],CRam1); UART1_Write_Text(CRam1);
 UART1_Write_CText(" Vert =");ByteToStr(RGB_Led[i][1],CRam1); UART1_Write_Text(CRam1);
 UART1_Write_CText(" Bleu =");ByteToStr(RGB_Led[i][2],CRam1); UART1_Write_Text(CRam1);
 CRLF1();
 }
 }

 void LOAD_Table_RGB()
 {
 int i, Flag;
 unsigned char cx;
 UART1_Write_CText("Charge EEPROM PIC -> Table \r\n");



 cx=0;
 for (i=0;i<8;i++)
 {
 RGB_Led[i][0]=EEPROM_Read(cx);
 RGB_Led[i][1]=EEPROM_Read(cx+1);
 RGB_Led[i][2]=EEPROM_Read(cx+2);
 cx=cx+3;
 }

 Liste_Table() ;





 }


void main()
{
#line 502 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
 Init_Hardware();
 txt=&TEXTE[0];


 Cpt_Color=0;
 LATC0_bit= 1;
 LATC1_bit= 1;
 LATC2_bit= 1;
 LATD=0xFF;


 UART1_Init(38400);
 while (UART1_Tx_Idle() == 1) UART1_Write(13);
 UART1_Write( 12 );
 Delay_ms(500);
 CRLF1();

 UART1_Write_CText("Mikroc Pro 6.620\r\n ");
 UART1_Write_CText("version :" "10-01-2016" "\r\n");
 UART1_Write_CText("Source :" "18F45K22_8leds_RGB_TMR2_500uS_160110.c" "\r\n");
 UART1_Write_CText("18F45K22 Ready for PIC\r\n ");

 UART1_Write_CText("UART1 via USB -> COM23 HTerminal\r\n ");
 UART1_Write_CText("Cdes Clavier pour Couleur 8 Leds RGB \r\n\r\n");
#line 537 "C:/_MikroC/_MesProjets_MikroC/_18F45K22_ReadyForPic_8leds_RGB/18F45K22_8leds_RGB_TMR2_500uS_160110.c"
 UART1_Write_CText("init UART1 38400,8,N,1\r\n ");




 LOAD_Table_RGB();

 Init_Timer4();
 cc=250;
 Cpt_Color=0;
 Cpt_RGB_Leds=0;
 LATB=0;
 LATD=0xFF;


 RCSTA1.SPEN = 1;
 RCSTA1.RCEN=1;
 RCSTA1.ADDEN=0;
 RAZ_UART1();
 PEIE_bit = 1;
 GIE_bit = 1;



 do
 {

 if(UART1_DataReady==1)
 {
 GIE_bit=0;
 TMR4ON_bit=0;
 UART1_Write_CText("Reception de : \r\n");
 UART1_Write_Text(buffer1); CRLF1();
 p1=0;
 p1=strstr(buffer1,"LED");
 if ( (p1>0) && (*(p1+4)=='='))
 {

 if ( (*(p1+3)>='0') && (*(p1+3)<'8') && ( (*(p1+5)=='0') || (*(p1+5)=='1') ))
 {
 Pos=*(p1+3)-'0';
 Cde=*(p1+5)-'0';

 Etat_PORTB=LATB;
 UART1_Write( 9 );
 strConstRamCpy(CRam1,"Pos=  Cde=  PortB= ");
 *(CRam1+ 4)= Pos+48;
 *(CRam1+10)= Cde+48;
 if (Cde==0) LATB = Etat_PORTB & ~(1<<Pos);
 if (Cde==1) LATB = Etat_PORTB | (1<<Pos) ;

 Etat_PORTB=LATB;
 ByteToHex(Etat_PORTB ,CRam1+18);
 UART1_Write_Text(CRam1);
 }
 }

 p1=strstr(buffer1,"LEDs_OFF");
 if (p1>0)
 { LATB=0;
 Etat_PORTB=0;
 }
 p1=strstr(buffer1,"LEDs_ON");
 if (p1>0)
 { LATB=0xFF;
 Etat_PORTB=0xFF;
 }

 p1=strstr(buffer1,"RGB");
 if (p1>0)
 {
 p1=strtok(p1,",");
 UART1_Write_Text(p1);CRLF1();
 c=*(p1+3);
 UART1_Write_CText("Led # ");UART1_Write(c);
 c=c-48;
 CRLF1();
 i=0;
 do
 {
 p1=strtok(0, ",");
 if (p1!=0)
 {

 UART1_Write_CText("  Parametre #");
 UART1_Write(i+48); UART1_Write( 9 );
 j=1;
 for(k=0;k<strlen(p1);k++)
 {
 if (isdigit(*(p1+k))==0)
 {
 j=0; break;
 }
 }
 if (j==1)
 {
 ValColor=atoi(p1);
 if (ValColor>253) ValColor=253;
 if (ValColor<1) ValColor=1;
 if ((c>=0) && (c<8))
 {
 RGB_Led[c][i]=ValColor;
 WordToStr(ValColor,CRam1);
 UART1_Write_CText(" ValColor ");UART1_Write_CText(Colors[i]);
 UART1_Write( 9 ); UART1_Write_Text(CRam1);
 CRLF1();
 Delay_ms(100);
 }

 }
 }
 i++;
 if(i>4) break;
 }
 while (p1!=0) ;
 p1=0;
 }


 p1=strstr(buffer1,"HELP");
 if ((p1>0) || (*(buffer1)=='?'))
 {
 UART1_Write_CText("Cde LED portB avec  x=num led de 0  7, etat 1 ou 0 ex: LED1=1 ou  LED1=0 \r\n");
 UART1_Write_CText("Cde Globale LEDs PortB avec : LEDs_ON ou LEDs_OFF \r\n");
 UART1_Write_CText("Cde Reglage LEDs RGB : RGBx,RRR,VVV,BBB<CR> \r\n");
 UART1_Write_CText("ex: RGB1,128,35,12 soit  Reglage LED1 R=128 V=35 B=12\r\n");
 UART1_Write_CText("SAVE_TABLE : Sauvegarde Tableau 8 leds -> PIC EEPROM \r\n");
 UART1_Write_CText("LIST_TABLE : Liste contenu TABLE de reglage RGB des 8 leds\r\n");
 UART1_Write_CText("LOAD_TABLE : Charge PIC EEPROM -> TABLE 8 leds\r\n");
 UART1_Write_CText("SAVE_TABLE : Sauve  TABLE 8 leds RGB -> PIC EEPROM\r\n");
 }

 p1=strstr(buffer1,"SAVE_TABLE");
 if (p1>0)
 {
 UART1_Write_CText("Sauvegarde Tableau -> PIC EEPROM \r\n");
 cx=0;
 for (i=0;i<8;i++)
 {
 EEPROM_Write(cx,RGB_Led[i][0]); Delay_ms(25);
 EEPROM_Write(cx+1,RGB_Led[i][1]); Delay_ms(25);
 EEPROM_Write(cx+2,RGB_Led[i][2]); Delay_ms(25);
 cx=cx+3;
 }
 Liste_Table() ;
 }
 p1=strstr(buffer1,"LIST_TABLE");
 if (p1>0)
 {
 Liste_Table();
 }
 p1=strstr(buffer1,"LOAD_TABLE");
 if (p1>0)
 {
 UART1_Write_CText("Charge PIC EEPROM -> Table \r\n");
 LOAD_Table_RGB();
 }


 CRLF1();
 RAZ_UART1();
 GIE_bit=1;
 TMR4ON_bit=1;
 }
 }
 while(1);
}
